﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TinyPosEntity.Entity;

namespace TinyPosEntity.Service
{
    public class ProductTypeService
    {
        static ProductTypeService instance;
        public static ProductTypeService Instance { get { Init(); return instance; } }

        private static void Init()
        {
            if (instance == null)
                instance = new ProductTypeService();
        }

        public void Create(ProductType targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                context.ProductTypes.Add(targetObject);
                context.SaveChanges();
            }
        }

        public void Create(List<ProductType> targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                foreach (ProductType type in targetObject)
                {
                    context.ProductTypes.Add(type);
                }

                context.SaveChanges();
            }
        }

        public List<ProductType> FindAll()
        {
            using (EntityContext context = new EntityContext())
            {
                var qry = from pt in context.ProductTypes
                          orderby pt.ProductTypeId ascending
                          select pt;

                if (qry.Count() < 1)
                    return null;

                return qry.ToList();
            }
        }

        public ProductType Find(ProductType targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                var qry = from pt in context.ProductTypes
                          where pt.Name.Equals(targetObject.Name)
                          select pt;

                if (qry.Count() < 1)
                    return null;

                return qry.ToArray()[0];
            }
        }

        public ProductType Find(string name)
        {
            using (EntityContext context = new EntityContext())
            {
                var qry = from pt in context.ProductTypes
                          where pt.Name.Equals(name)
                          select pt;

                if (qry.Count() < 1)
                    return null;

                return qry.ToArray()[0];
            }
        }

        public void Remove(ProductType targetObject)
        {
            using (EntityContext context = new EntityContext())
            {
                context.Database.ExecuteSqlCommand(
                    "DELETE FROM dbo.Students WHERE ProductTypeId = {0}",
                    targetObject.ProductTypeId);
            }
        }

        public void Remove(string name)
        {
            using (EntityContext context = new EntityContext())
            {
                context.Database.ExecuteSqlCommand(
                    "DELETE FROM dbo.Students WHERE Name = {0}",
                    name);
            }
        }
    }
}
